// Code generated by go-swagger; DO NOT EDIT.

package network_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-network/preview/2020-09-07/models"
	cloud "github.com/hashicorp/hcp-sdk-go/clients/cloud-shared/v1/models"
)

// DeleteHVNRouteReader is a Reader for the DeleteHVNRoute structure.
type DeleteHVNRouteReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteHVNRouteReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteHVNRouteOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewDeleteHVNRouteDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteHVNRouteOK creates a DeleteHVNRouteOK with default headers values
func NewDeleteHVNRouteOK() *DeleteHVNRouteOK {
	return &DeleteHVNRouteOK{}
}

/*
DeleteHVNRouteOK describes a response with status code 200, with default header values.

A successful response.
*/
type DeleteHVNRouteOK struct {
	Payload *models.HashicorpCloudNetwork20200907DeleteHVNRouteResponse
}

// IsSuccess returns true when this delete h v n route o k response has a 2xx status code
func (o *DeleteHVNRouteOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this delete h v n route o k response has a 3xx status code
func (o *DeleteHVNRouteOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete h v n route o k response has a 4xx status code
func (o *DeleteHVNRouteOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete h v n route o k response has a 5xx status code
func (o *DeleteHVNRouteOK) IsServerError() bool {
	return false
}

// IsCode returns true when this delete h v n route o k response a status code equal to that given
func (o *DeleteHVNRouteOK) IsCode(code int) bool {
	return code == 200
}

func (o *DeleteHVNRouteOK) Error() string {
	return fmt.Sprintf("[DELETE /network/2020-09-07/organizations/{hvn.location.organization_id}/projects/{hvn.location.project_id}/networks/{hvn.id}/routes/{id}][%d] deleteHVNRouteOK  %+v", 200, o.Payload)
}

func (o *DeleteHVNRouteOK) String() string {
	return fmt.Sprintf("[DELETE /network/2020-09-07/organizations/{hvn.location.organization_id}/projects/{hvn.location.project_id}/networks/{hvn.id}/routes/{id}][%d] deleteHVNRouteOK  %+v", 200, o.Payload)
}

func (o *DeleteHVNRouteOK) GetPayload() *models.HashicorpCloudNetwork20200907DeleteHVNRouteResponse {
	return o.Payload
}

func (o *DeleteHVNRouteOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.HashicorpCloudNetwork20200907DeleteHVNRouteResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteHVNRouteDefault creates a DeleteHVNRouteDefault with default headers values
func NewDeleteHVNRouteDefault(code int) *DeleteHVNRouteDefault {
	return &DeleteHVNRouteDefault{
		_statusCode: code,
	}
}

/*
DeleteHVNRouteDefault describes a response with status code -1, with default header values.

An unexpected error response.
*/
type DeleteHVNRouteDefault struct {
	_statusCode int

	Payload *cloud.GrpcGatewayRuntimeError
}

// Code gets the status code for the delete h v n route default response
func (o *DeleteHVNRouteDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this delete h v n route default response has a 2xx status code
func (o *DeleteHVNRouteDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this delete h v n route default response has a 3xx status code
func (o *DeleteHVNRouteDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this delete h v n route default response has a 4xx status code
func (o *DeleteHVNRouteDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this delete h v n route default response has a 5xx status code
func (o *DeleteHVNRouteDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this delete h v n route default response a status code equal to that given
func (o *DeleteHVNRouteDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *DeleteHVNRouteDefault) Error() string {
	return fmt.Sprintf("[DELETE /network/2020-09-07/organizations/{hvn.location.organization_id}/projects/{hvn.location.project_id}/networks/{hvn.id}/routes/{id}][%d] DeleteHVNRoute default  %+v", o._statusCode, o.Payload)
}

func (o *DeleteHVNRouteDefault) String() string {
	return fmt.Sprintf("[DELETE /network/2020-09-07/organizations/{hvn.location.organization_id}/projects/{hvn.location.project_id}/networks/{hvn.id}/routes/{id}][%d] DeleteHVNRoute default  %+v", o._statusCode, o.Payload)
}

func (o *DeleteHVNRouteDefault) GetPayload() *cloud.GrpcGatewayRuntimeError {
	return o.Payload
}

func (o *DeleteHVNRouteDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud.GrpcGatewayRuntimeError)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
